define(["require", "exports", "jrptlib/Nls"], function (require, exports, NLS) {
    "use strict";
    function getLanguage() {
        if ("languages" in navigator) {
            return navigator.languages[0];
        }
        return navigator.userLanguage || navigator.language;
    }
    var defaultLocale = {
        numberFormat: d3.format,
        timeFormat: d3.time.format
    };
    function jsonRetrieved(o, lang, callback) {
        if (o) {
            callback(d3.locale(o));
        }
        else {
            var dash = lang.lastIndexOf("-");
            if (dash > 0) {
                retrieveJson(lang.substring(0, dash), callback);
            }
            else {
                callback(defaultLocale);
            }
        }
    }
    function retrieveJson(lang, callback) {
        NLS.loadJSON("libs/d3/locales/" + lang + ".json", function (o) { return jsonRetrieved(o, lang, callback); });
    }
    return {
        load: function (id, require, callback) {
            var lang = getLanguage();
            retrieveJson(lang, callback);
        }
    };
});
