var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "jrptlib/Widget"], function (require, exports, Widget) {
    "use strict";
    var TableWrapper = (function (_super) {
        __extends(TableWrapper, _super);
        function TableWrapper(container) {
            var _this = _super.call(this, container) || this;
            _this.visibleLines = -1;
            _this.fixedNFirstColumns = -1;
            _this.showAllLines = true;
            _this.setClassName("tableviewer");
            return _this;
        }
        TableWrapper.prototype.setFixedNFirstColumns = function (nbcolumns) {
            this.fixedNFirstColumns = nbcolumns;
        };
        TableWrapper.prototype.setShowAllLines = function (showAll) {
            this.showAllLines = showAll;
        };
        TableWrapper.prototype.isShowAllLines = function () {
            return this.showAllLines;
        };
        TableWrapper.prototype.setVisibleLines = function (nb) {
            this.visibleLines = nb;
            this.showAllLines = false;
        };
        TableWrapper.prototype.setAltClass = function (altClass) {
            this.altClass = altClass;
        };
        TableWrapper.prototype.setTable = function (table) {
            this.renderTable(table);
        };
        TableWrapper.prototype.getHeaderTable = function () {
            return $(this.fixedHeader).find(".tableviewer-table");
        };
        TableWrapper.prototype.getFixedColumnHeaderTable = function () {
            return $(this.fixedColHeader).find(".tableviewer-table");
        };
        TableWrapper.prototype.getWidthColumns = function (table, nbcol) {
            var w = 0;
            $(table).find("thead tr").children().each(function (idx) {
                if (idx < nbcol)
                    w += $(this).outerWidth();
            });
            return w;
        };
        TableWrapper.prototype.renderTable = function (table) {
            var _this = this;
            $(table).appendTo($(this.getContainer()));
            $(this.fixedHeader).remove();
            $(this.fixedBody).remove();
            $(this.fixedFooter).remove();
            $(this.fixedColumn).remove();
            $(this.fixedColHeader).remove();
            $(this.fixedColBody).remove();
            this.fixedHeader = $("<div>").addClass("tableviewer-header").appendTo($(this.getContainer()));
            this.fixedBody = $("<div>").addClass("tableviewer-body").appendTo($(this.getContainer()));
            if ($(table).find("tfoot").length > 0)
                this.fixedFooter = $("<div>").addClass("tableviewer-footer").appendTo($(this.getContainer()));
            $(table).find("thead .tableviewer-cell").remove();
            $(table).find("thead tr th").each(function () {
                $("<div>").addClass("tableviewer-cell").width($(this).width()).appendTo($(this));
            });
            $(table).find("thead tr td").each(function () {
                $("<div>").addClass("tableviewer-cell").width($(this).width()).appendTo($(this));
            });
            var tableH = $("<table>").addClass("tableviewer-table " + $(table).attr("class"))
                .css("margin-left", "0px")
                .appendTo(this.fixedHeader);
            if ($(table).attr("id")) {
                tableH.attr("id", $(table).attr("id"));
            }
            $(table).find("colgroup").clone().appendTo(tableH);
            $(table).find("thead").clone().appendTo(tableH);
            var headerH = $(tableH).outerHeight();
            $(table).addClass("tableviewer-table").appendTo($(this.fixedBody));
            $(table).css("margin-top", "-" + headerH + "px");
            this.fixedBody.scroll(function () {
                _this.scrollFixedHeader(_this.fixedBody.scrollLeft());
            });
            if (this.fixedNFirstColumns > 0) {
                var fb = $("<div>").addClass("tableviewer-fixed-body").prependTo($(this.getContainer()));
                $(this.fixedHeader).appendTo($(fb));
                $(this.fixedBody).appendTo($(fb));
                $(this.fixedFooter).appendTo($(fb));
                var fc = $("<div>").addClass("tableviewer-fixed-column").prependTo($(this.getContainer()));
                $(this.fixedHeader).clone().appendTo(fc);
                $(this.fixedBody).clone().appendTo(fc);
                $(this.fixedFooter).clone().appendTo(fc);
                var htbody = 0;
                $(fb).find(".tableviewer-body table tbody").each(function () {
                    htbody += $(this).height();
                });
                $(fc).find(".tableviewer-body").css("height", htbody);
                $(fc).find("th").each(function () {
                    if (parseInt($(this).attr("colspan")) > 1) {
                        $(this).css("white-space", "nowrap");
                    }
                });
                $(fc).find(".tableviewer-body table").css("margin-top", "0px");
                $(fc).outerWidth(this.getWidthColumns(table, this.fixedNFirstColumns) - 1);
                $(fc).find(".tableviewer-header table colgroup").children().slice(1).remove();
                $(fc).find(".tableviewer-header table thead tr").children().slice(1).remove();
                $(fc).find(".tableviewer-body table thead").remove();
                $(fc).find(".tableviewer-body table colgroup").children().slice(1).remove();
                var nbcol = this.fixedNFirstColumns;
                $(fc).find(".tableviewer-header table thead tr").children().each(function (idx) {
                    var cellH = $($(table).find("thead tr").children().get(idx)).height();
                    $(this).height(cellH);
                });
                $(fc).find(".tableviewer-body table tbody tr").each(function (idx) {
                    var hM = 0;
                    var originalLine = $($(table).find("tbody tr")[idx]);
                    originalLine.children().each(function () {
                        hM = Math.max(hM, $(this).outerHeight());
                    });
                    $(this).children().slice(nbcol).remove();
                    $(this).children().each(function (index) {
                        $(this).outerHeight(hM);
                        $(this).width($(originalLine.children().get(index)).width());
                    });
                });
                $(fc).appendTo($(this.getContainer()));
                this.fixedColBody = fb;
                this.fixedColHeader = fc;
            }
        };
        TableWrapper.prototype.scrollFixedColumns = function (value) {
            if (this.fixedNFirstColumns != -1) {
                $(this.getContainer()).find(".columnFixedPane").css("top", value);
            }
        };
        TableWrapper.prototype.scrollFixedHeader = function (value) {
            $(this.fixedHeader).find("table").css("margin-left", "-" + value + "px");
        };
        return TableWrapper;
    }(Widget));
    return TableWrapper;
});
