var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "jrptlib/Evented", "jrptlib/Properties!SHAREMSG", "model/session/Host"], function (require, exports, Evented, SHAREMSG, Host) {
    "use strict";
    var AbstractExportHTML = (function (_super) {
        __extends(AbstractExportHTML, _super);
        function AbstractExportHTML() {
            return _super.call(this) || this;
        }
        AbstractExportHTML.prototype.share = function (session, report) {
            this.session = session;
            this.report = report;
            this.open(session, report);
        };
        AbstractExportHTML.prototype.open = function (session, report) {
            var _this = this;
            var dialog = this.openDialog(report.reportKind);
            var closeDialog = function () {
                dialog.close();
                dialog.destroy();
            };
            dialog.on("apply", function (button) {
                $(button).button("option", "disabled", true);
                _this.exportData(report.reportKind, closeDialog);
            });
            dialog.on("cancel", function () {
                $("#ExportPopupIframe").remove();
                closeDialog();
            });
            this.progressBar = dialog.getProgressBar(SHAREMSG.GenerateReport);
            this.progressBar.progressbar("option", "value", false);
        };
        AbstractExportHTML.prototype.exportData = function (reportKind, terminated) {
            var _this = this;
            var encoding = "default";
            var reports = "";
            var report_list = this.getReportIds();
            for (var i_1 = 0; i_1 < report_list.length; i_1++) {
                reports += "report_id=" + report_list[i_1];
                if (i_1 < report_list.length - 1)
                    reports += "&";
            }
            var sset = this.session.sessionSet;
            var sessions = "";
            var session_list = this.getSessionPaths();
            for (var i_2 = 0; i_2 < session_list.length; i_2++) {
                sessions += "session_path=" + session_list[i_2];
                if (i_2 < session_list.length - 1)
                    sessions += "&";
            }
            var selected = this.session.getSelectedTimeRangeIndices();
            var tranges = "";
            var trange_list = new Array();
            for (var i = 0; i < selected.length; i++) {
                tranges += "time_range=" + selected[i];
                trange_list.push(selected[i]);
                if (i < selected.length - 1)
                    tranges += "&";
            }
            var hostsRoot = this.session.hostsRoot;
            var hosts;
            var grouping = hostsRoot.getGrouping();
            if (grouping.length == 0) {
                hosts = hostsRoot.getHosts();
            }
            else {
                hosts = [];
                var cats = hostsRoot.getCategories();
                for (var _i = 0, grouping_1 = grouping; _i < grouping_1.length; _i++) {
                    var catid = grouping_1[_i];
                    var cat = hostsRoot.getCategory(catid);
                    if (!cat || !cat.hasValues())
                        continue;
                    var vals = cat.getValues();
                    for (var j = 0; j < vals.length; j++) {
                        hosts.push(vals[j]);
                    }
                }
            }
            var hosts_list = [];
            for (var i = 0; i < hosts.length; i++) {
                if (hosts[i].isEnabled())
                    if (hosts[i] instanceof Host)
                        hosts_list.push(hosts[i].getName());
                    else
                        hosts_list.push(hosts[i].getValue());
            }
            var thosts = "";
            var thosts_list = [];
            if (hosts_list.length != hosts.length || hostsRoot.isCompare()) {
                for (var _a = 0, _b = hostsRoot.getGroups(); _a < _b.length; _a++) {
                    var i_3 = _b[_a];
                    thosts += "&hostgroup=" + i_3.getHostQuery();
                    thosts_list.push(i_3.getHostQuery());
                }
            }
            if (_app.isEclipseBrowser()) {
                exportEclipseBrowserHTML(this.session.sessionPath, session_list, report_list, reportKind, trange_list, thosts_list, this.display_mode, "default");
                terminated();
                return;
            }
            this.progressBar.show();
            var href = this.session.getBaseRequestUrl() + "/export/html" +
                "?encoding=" + encoding +
                "&" + reports +
                (tranges != "" ? "&" + tranges : "") +
                thosts +
                "&userId=default" +
                (this.display_mode ? "&display=" + this.display_mode : "") +
                "&" + sessions;
            $("#ExportPopupIframe").remove();
            var ifr = $('<iframe/>', {
                id: 'ExportPopupIframe',
                src: href,
                style: 'display:none',
                load: function () {
                    if ($(ifr).contents().find("body").text() == "error") {
                        _this.progressBar.hide();
                        $("<p>").insertAfter(_this.progressBar)
                            .addClass("ui-dialog-errormessage")
                            .text(SHAREMSG.GenerationError);
                        return;
                    }
                    _this.progressBar.hide();
                    terminated();
                }
            });
            $('body').append(ifr);
        };
        AbstractExportHTML.prototype.isEnabled = function (id, session) {
            return !_app.session.isLive();
        };
        return AbstractExportHTML;
    }(Evented));
    return AbstractExportHTML;
});
