var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "jrptlib/Evented", "view/query/GInstanceQueryProvider", "jrptlib/Properties!APPMSG", "jrptlib/Offline!"], function (require, exports, Evented, GInstanceQueryProvider, APPMSG, Offline) {
    "use strict";
    var InstancesSelector = (function (_super) {
        __extends(InstancesSelector, _super);
        function InstancesSelector(wildcards, allAllowed, pageId, parent) {
            var _this = _super.call(this) || this;
            _this.instancep = [];
            _this.wildcards = wildcards;
            _this.instances = {};
            _this.form = $("<span>")
                .addClass("instances")
                .appendTo(parent);
            var page = _this;
            for (var i = 0; i < wildcards.length; i++) {
                var index = i;
                _this.select = $("<select>")
                    .appendTo(_this.form)
                    .addClass("instance-selector")
                    .attr("id", "is" + pageId + "_" + i)
                    .selectmenu({
                    change: function (event) {
                        var val = $(this).val();
                        if (val == "*")
                            val = undefined;
                        page.replaceInstance(index, val);
                    }
                });
                if (allAllowed) {
                    $("<option value='*'>").text(APPMSG.AllInstances).appendTo($(_this.select));
                    _this.select.val(0);
                }
            }
            $(".instance-selector").selectmenu('refresh');
            $(".instance-selector").selectmenu("option", "width", "auto");
            console.log("w length = " + wildcards.length);
            var _loop_1 = function (i_1) {
                this_1.instancep[i_1] = new GInstanceQueryProvider();
                this_1.instancep[i_1].setIndex(i_1);
                this_1.instancep[i_1].setWildcards(this_1.wildcards);
                this_1.instancep[i_1].setInstances(this_1.instances);
                this_1.instancep[i_1].on("instancesListChanged", function (data) {
                    _this.emit("instancesListChanged", {});
                    _this.setList(i_1, data);
                });
            };
            var this_1 = this;
            for (var i_1 = 0; i_1 < wildcards.length; i_1++) {
                _loop_1(i_1);
            }
            return _this;
        }
        InstancesSelector.prototype.remove = function () {
            this.form.remove();
            for (var i = 0; i < this.wildcards.length; i++) {
                this.instancep[i].dispose();
            }
        };
        InstancesSelector.prototype.setSession = function (session) {
            this.session = session;
            if (session) {
                this.fillValues(0);
            }
            else {
                for (var i = 0; i < this.wildcards.length; i++) {
                    this.clearWildcardValues(i);
                }
            }
        };
        InstancesSelector.prototype.getInstances = function () {
            return this.instances;
        };
        InstancesSelector.prototype.setInstances = function (instances, skipSelectorUpdate) {
            this.instances = instances;
            this.emit("instancesChanged", {});
            if (!skipSelectorUpdate) {
                for (var i = 0; i < this.wildcards.length; i++) {
                    this.setSpecificInstance(i, instances[this.wildcards[i]]);
                }
            }
        };
        InstancesSelector.prototype.replaceInstance = function (windex, instance) {
            this.instances[this.wildcards[windex]] = instance;
            this.setInstances(this.instances, true);
            this.fillValues(windex + 1);
        };
        InstancesSelector.prototype.setSpecificInstance = function (windex, instance) {
            this.select.eq(windex);
            if (instance) {
                var option = this.select.children("option")
                    .filter(function (i, e) { return $(e).text() == instance; });
                if (option.length == 0) {
                    $("<option>" + instance + "</option>").appendTo(this.select);
                }
            }
            this.select.val(instance == undefined ? "*" : instance);
            this.select.selectmenu('refresh');
        };
        InstancesSelector.prototype.fillValues = function (from) {
            if (Offline.isActivated())
                return;
            for (var i = from; i < this.wildcards.length; i++) {
                this.clearWildcardValues(i);
                this.fillWildcardValues(i);
                if (this.instances[this.wildcards[i]] === undefined)
                    break;
            }
        };
        InstancesSelector.prototype.fillWildcardValues = function (windex) {
            this.instancep[windex].setSession(this.session);
            this.instancep[windex].setIndex(windex);
            this.instancep[windex].setInstances(this.instances);
            this.instancep[windex].setOn();
        };
        InstancesSelector.prototype.clearWildcardValues = function (windex) {
            var select = this.form.find(".instance-selector").eq(windex);
            var currentInstance = this.instances[this.wildcards[windex]];
            var option = select.children("option")
                .filter(function (i, e) { var v = $(e).text(); return v != "*" && v != currentInstance; });
        };
        InstancesSelector.prototype.setList = function (windex, values) {
            this.select.eq(windex);
            var _loop_2 = function (v) {
                option = this_2.select.children("option")
                    .filter(function (i, e) { return $(e).text() == v; });
                if (option.length == 0) {
                    $("<option>" + v + "</option>").appendTo(this_2.select);
                }
            };
            var this_2 = this, option;
            for (var _i = 0, values_1 = values; _i < values_1.length; _i++) {
                var v = values_1[_i];
                _loop_2(v);
            }
            this.select.selectmenu('refresh');
        };
        return InstancesSelector;
    }(Evented));
    return InstancesSelector;
});
