var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "jrptlib/Widget", "jrptlib/Listview", "ui/PageSelectorContentProvider", "ui/ReportLabelProvider", "ui/Prefs!", "jrptlib/Properties!APPMSG"], function (require, exports, Widget, Listview, PageSelectorContentProvider, ReportLabelProvider, Prefs, APPMSG) {
    "use strict";
    var PageSelector = (function (_super) {
        __extends(PageSelector, _super);
        function PageSelector(widget) {
            var _this = _super.call(this, widget) || this;
            _this.list = $(widget).find(".page_selector_scrollview");
            _this.scrollview = new Listview(_this.list[0]);
            _this.scrollview.setContentProvider(new PageSelectorContentProvider());
            _this.scrollview.setLabelProvider(new ReportLabelProvider());
            _this.scrollview.on("selectionChanged", function (page) {
                var v_item = _this.scrollview.findViewItem(page);
                _this.updateChildrenPagesCombo(page);
                _this.selectedRootPage = page.getRootPage();
                _this.selectedSubPage = page.hasParentPage() ? page : null;
                _this.updatePageSelectmenu();
                _this.updateSelectVisibility();
                var help = $(v_item).find(".help-context");
                if (help.length > 0)
                    return;
                if (_app.isOffline())
                    return;
                if ($(page.getModel()).attr("helpId")) {
                    var h3 = $(v_item).find(".label");
                    _app.getHelpSystem().setHelp($(h3), $(page.getReport().getModel()).attr("helpProvider") + "." + $(page.getModel()).attr("helpId"), {
                        of: $("#page_selector"),
                        my: "left+20px top+15", at: "right top", collision: "none"
                    });
                }
            });
            $(widget).find(".reduce-control").click(function () {
                _this.setShowPagesPanel(!Prefs.showPagesPanel);
                Prefs.showPagesPanel = !Prefs.showPagesPanel;
                Prefs.save();
                _this.updateSelectVisibility();
            });
            $(widget).find(".show-subpages").click(function () {
                _this.showSubPages(!Prefs.showSubPages);
                Prefs.showSubPages = !Prefs.showSubPages;
                Prefs.save();
                _this.updateSelectVisibility();
            });
            $(widget).find("#page_selector_reduced_panel").hover(function () { $(this).toggleClass("hover"); }, function () { $(this).toggleClass("hover"); }).focusin(function () { $(this).toggleClass("focused"); })
                .focusout(function () { $(this).toggleClass("focused"); });
            _this.select = $("<select>").appendTo($("#page_selector_reduced_panel_pagetitle")).selectmenu();
            _this.select.on("selectmenuchange", function (event, ui) { _this.selectRootPage(event, ui); });
            _this.select.selectmenu("instance")._renderItem = function (ul, item) {
                var li = $("<li>");
                if (item.element.data("page").hasParentPage()) {
                    li.addClass("page-item-child");
                }
                this._setText(li, item.label);
                return li.appendTo(ul);
            };
            _this.select.selectmenu("option", "width", "auto");
            _this.select_subpages = $("<select>").appendTo($("#page_selector_reduced_panel_pagetitle")).selectmenu({
                open: function () {
                    var v = _this.select_subpages.val();
                    _this.updateChildrenPagesCombo(_this.selectedRootPage);
                    _this.select_subpages.val(v);
                    _this.select_subpages.selectmenu('refresh');
                }
            });
            _this.select_subpages.on("selectmenuchange", function (event, ui) { _this.selectSubPage(event, ui); });
            _this.select_subpages.selectmenu("option", "width", "auto");
            _this.setEditMode(false);
            var checkVisible = setInterval(function () {
                if (!$(_this.list).is(':visible'))
                    return;
                clearInterval(checkVisible);
                _this.resize();
            }, 1000);
            return _this;
        }
        PageSelector.prototype.updatePageSelectmenu = function () {
            var _this = this;
            if (this.selectedRootPage) {
                this.select.off("selectmenuchange");
                this.select.val(this.selectedRootPage.getTitle());
                this.select.selectmenu('refresh');
                this.select.on("selectmenuchange", function (ui, event) { _this.selectRootPage(ui, event); });
            }
        };
        PageSelector.prototype.updateSubPageSelectmenu = function () {
            var _this = this;
            if (this.selectedSubPage) {
                this.select_subpages.off("selectmenuchange");
                this.select_subpages.val(this.selectedSubPage.getTitle());
                this.select_subpages.selectmenu('refresh');
                this.select_subpages.on("selectmenuchange", function (ui, event) { _this.selectSubPage(ui, event); });
            }
        };
        PageSelector.prototype.selectRootPage = function (event, ui) {
            var v = this.select.val();
            for (var _i = 0, _a = this.report.getAllPages(); _i < _a.length; _i++) {
                var p = _a[_i];
                if (p.getTitle() === v) {
                    this.report.setPage(p);
                    break;
                }
            }
        };
        PageSelector.prototype.selectSubPage = function (event, ui) {
            var v = this.select_subpages.val();
            var page = this.getSelection();
            var subpages = [];
            this.report.getChildrenPages(page, subpages);
            for (var _i = 0, subpages_1 = subpages; _i < subpages_1.length; _i++) {
                var p = subpages_1[_i];
                if (p.getTitle() === v) {
                    this.selectedSubPage = p;
                    this.report.setPage(p);
                    return;
                }
            }
            this.report.setPage(page);
        };
        PageSelector.prototype.updateSelectVisibility = function () {
            var page = this.scrollview.getSelection();
            if (page == null)
                return;
            var haschildren = page && page.hasChildrenPage();
            var hasParent = page.hasParentPage();
            var showSubPages = $(this.getContainer()).find(".show-subpages").hasClass("checked");
            if ($(this.getContainer()).hasClass("reduced")) {
                this.select.selectmenu("widget").show();
                if (haschildren || hasParent) {
                    this.select_subpages.selectmenu("widget").show();
                }
                else {
                    this.select_subpages.selectmenu("widget").hide();
                }
            }
            else {
                this.select.selectmenu("widget").hide();
                if (haschildren && !showSubPages) {
                    this.select_subpages.selectmenu("widget").show();
                }
                else {
                    this.select_subpages.selectmenu("widget").hide();
                }
            }
        };
        PageSelector.prototype.setShowPagesPanel = function (val) {
            if (!val) {
                $(this.getContainer()).addClass("reduced");
                $("#page_selector_reduced_panel_pagetitle").addClass("reduced");
            }
            else {
                $(this.getContainer()).removeClass("reduced");
                $("#page_selector_reduced_panel_pagetitle").removeClass("reduced");
            }
            if (val != Prefs.showPagesPanel)
                this.emit("toogleSize", {});
            if (!$(this.getContainer()).hasClass("reduced")) {
                $(this.getContainer()).find(".page_selector_size_button").focus();
            }
        };
        PageSelector.prototype.getListview = function () {
            return this.scrollview;
        };
        PageSelector.prototype.resize = function () {
            var h = window.innerHeight;
            var w = window.innerWidth;
            var apph = $("#app_header").outerHeight(true);
            var mh = 0;
            var hh = $(this.container).find("header").outerHeight(true);
            var offt = apph + mh + hh;
            h = h - offt;
            var footer = $(this.container).find("footer");
            if (footer.length && $(footer).is(':visible'))
                h = h - $(footer).outerHeight();
            $(this.list).css("height", h);
            $(this.container).find("#page_selector_reduced_panel").css("top", (h / 2)
                - $(this.container).find("#page_selector_reduced_panel").height());
        };
        PageSelector.prototype.setInput = function (input) {
            this.scrollview.setModelModifierProvider(input);
            this.scrollview.getContentProvider().setAddSubPages(Prefs.showSubPages);
            this.scrollview.setInput(input);
            this.report = input;
            this.updatePageCombo();
        };
        PageSelector.prototype.updatePageCombo = function () {
            var _this = this;
            this.select.find('option').remove().end();
            if (this.report != null) {
                new PageSelectorContentProvider().getElements(this.report, function (data) {
                    for (var _i = 0, data_1 = data; _i < data_1.length; _i++) {
                        var p = data_1[_i];
                        $("<option>" + p.getTitle() + "</option>").appendTo(_this.select).data("page", p);
                    }
                    _this.updatePageSelectmenu();
                });
            }
        };
        PageSelector.prototype.updateChildrenPagesCombo = function (page) {
            this.select_subpages.find('option').remove().end();
            if (page == null)
                return;
            if (page != null && !page.hasChildrenPage())
                return;
            var children = [];
            this.report.getChildrenPages(page, children);
            $("<option>" + APPMSG.PageSelector_SelectSubPage + "</option>").appendTo(this.select_subpages);
            for (var _i = 0, children_1 = children; _i < children_1.length; _i++) {
                var p = children_1[_i];
                $("<option>" + p.getTitle() + "</option>").appendTo(this.select_subpages).data("page", p);
            }
            this.select_subpages.selectmenu('refresh');
        };
        PageSelector.prototype.getSelection = function () {
            return this.scrollview.getSelection();
        };
        PageSelector.prototype.setSelection = function (page) {
            if (!page)
                return;
            this.selectedRootPage = page.getRootPage();
            this.scrollview.setSelection(!Prefs.showSubPages ? this.selectedRootPage : page);
            this.selectedSubPage = page.hasParentPage() ? page : null;
            this.updatePageSelectmenu();
            this.updateSubPageSelectmenu();
            this.updateSelectVisibility();
        };
        PageSelector.prototype.scrollToItem = function (page) {
            this.scrollview.scrollToItem(page);
        };
        PageSelector.prototype.renamePage = function (page, text) {
            var item = this.scrollview.updateItem(page);
        };
        PageSelector.prototype.showSubPages = function (val) {
            var sel = this.scrollview.getSelection();
            this.scrollview.getContentProvider().setAddSubPages(val);
            this.scrollview.update();
            this.updatePageCombo();
            if (val) {
                $(this.getContainer()).find(".show-subpages").addClass("checked");
            }
            else {
                $(this.getContainer()).find(".show-subpages").removeClass("checked");
            }
            this.scrollview.setSelection(sel);
        };
        PageSelector.prototype.open = function () {
            $(this.container).show();
        };
        PageSelector.prototype.close = function () {
            $(this.container).hide();
        };
        PageSelector.prototype.isOpen = function () {
            return $(this.container).is(':visible');
        };
        PageSelector.prototype.setEditMode = function (val) {
            var sel = this.selectedRootPage;
            this.scrollview.setContentProvider(new PageSelectorContentProvider(!val));
            this.scrollview.setEditMode(val);
            this.scrollview.setSelection(sel);
        };
        return PageSelector;
    }(Widget));
    return PageSelector;
});
