var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "ui/ChartView", "view/GPie", "view/GError", "view/query/QueryFactory"], function (require, exports, ChartView, GPie_1, GError, QueryFactory_1) {
    "use strict";
    var PieChartView = (function (_super) {
        __extends(PieChartView, _super);
        function PieChartView(container, page, view_id, view_node, instances) {
            var _this = _super.call(this, container, page, view_id, view_node, instances) || this;
            _this.setRatio(1);
            return _this;
        }
        PieChartView.prototype.getSeries = function () {
            return GPie_1.PieSeries;
        };
        PieChartView.prototype.getQueryFactory = function () {
            return this.provider;
        };
        PieChartView.prototype.createQueryFactory = function () {
            return new QueryFactory_1.PieQueryFactory(this.getCounterQuerySet(), this.getSession());
        };
        PieChartView.prototype.createChartAndProviders = function () {
            try {
                this.provider = this.createQueryFactory();
                this.setupBusy(this.provider.getQueryProvider());
                this.pieChart = new GPie_1.GPie(this.provider.getViewProvider(), this.computeGPieOptions(this.provider));
            }
            catch (error) {
                this.pieChart = new GError(error);
            }
        };
        PieChartView.prototype.computeGPieOptions = function (provider) {
            return {
                dimensions: provider.getSeriesOptions(this.getSeriesOptions()),
                donut: false
            };
        };
        PieChartView.prototype.createContents = function (parent, w, h) {
            var _this = this;
            this.createChartAndProviders();
            this.sessionListeners = [
                this.getSession().on("selectedTimeRangesChanged", function () { return _this.refreshContents(); }),
                this.getSession().sessionSet.on("selectionChanged", function () { return _this.refreshContents(); }),
                this.getSession().on("hosts", function (details) {
                    if (details.compareChanged)
                        _this.refreshContents();
                })
            ];
            _super.prototype.createContents.call(this, parent, w, h);
        };
        PieChartView.prototype.clearContents = function () {
            _super.prototype.clearContents.call(this);
            if (this.provider) {
                this.provider.dispose();
                this.provider = null;
            }
            for (var i = 0; i < this.sessionListeners.length; i++)
                this.sessionListeners[i].remove();
            this.sessionListeners = undefined;
            this.pieChart = null;
        };
        PieChartView.prototype.createLegend = function (parent) {
            this.pieChart.renderLegend(d3.select(parent));
        };
        PieChartView.prototype.createChart = function (parent, w, h) {
            this.pieChart.renderContents(d3.select(parent), w, h);
        };
        PieChartView.prototype.chartResized = function (parent, w, h) {
            if (this.pieChart) {
                this.pieChart.resize(w, h);
            }
        };
        return PieChartView;
    }(ChartView));
    return PieChartView;
});
