define(["require", "exports", "jrptlib/Url", "dojo/json"], function (require, exports, Url, json) {
    "use strict";
    function saveThisAsJson() {
        var url = new Url("/analytics/prefs");
        url.request_post({
            data: json.stringify(this),
            headers: {
                "Content-Type": "application/json; charset=utf-8",
                "Accept": "application/json"
            },
            handleAs: "json"
        });
    }
    return {
        load: function (id, require, callback) {
            var url = new Url("/analytics/prefs");
            url.request_get({
                handleAs: "json",
                headers: { "Accept": "application/json" }
            }).then(function (data) {
                data.save = saveThisAsJson;
                callback(data);
            }, function (error) {
                console.log("Unable to retrieve preferences: " + error);
                callback(null);
            });
        }
    };
});
