var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "jrptlib/Evented", "view/util/DimensionUtil", "view/prov/GOrnamentProviders", "view/comps/MultiLegend", "view/comps/SeriesAxis", "view/comps/ValuesAxis", "view/comps/BarsContent", "view/comps/Slider", "../jrptlib/PopupMenu", "../jrptlib/Tooltip", "../jrptlib/Nls", "view/util/Margin", "jrptlib/Properties!APPMSG"], function (require, exports, Evented, du, GOrnamentProviders_1, MultiLegend_1, SeriesAxis_1, ValuesAxis_1, BarsContent, Slider_1, PopupMenu, Tooltip, NLS, Margin, APPMSG) {
    "use strict";
    exports.__esModule = true;
    exports.BarSeries = {
        ids: ["primary", "secondary", "stack"],
        labels: [APPMSG.PrimaryBarSerie, APPMSG.SecondaryBarSerie, APPMSG.StackBarSerie]
    };
    var GBarsOptions = (function () {
        function GBarsOptions() {
            this.tickStyle = "tick";
        }
        return GBarsOptions;
    }());
    exports.GBarsOptions = GBarsOptions;
    function ornamentKinds(options) {
        if (options.series[1] != null) {
            if (options.series[2] != null) {
                return [null, GOrnamentProviders_1.GOrnamentKind.COLOR_SHADEABLE, GOrnamentProviders_1.GOrnamentKind.SHADE];
            }
            else {
                return [null, GOrnamentProviders_1.GOrnamentKind.COLOR, null];
            }
        }
        else if (options.series[2] != null) {
            return [null, null, GOrnamentProviders_1.GOrnamentKind.COLOR];
        }
        else if (options.series[0] != null) {
            return [null, null, null];
        }
        return [null, null, null];
    }
    var GBars = (function (_super) {
        __extends(GBars, _super);
        function GBars(provider, options) {
            var _this = _super.call(this) || this;
            if (options.scaleOnSelection === undefined)
                options.scaleOnSelection = true;
            var dimOptions = options.dimensions;
            dimOptions.validate(provider.dimensionsCount());
            provider = du.swap(provider, dimOptions.series);
            _this.multiLegend = new MultiLegend_1.TabularMultiLegend(provider, options.dimensions, ornamentKinds(options.dimensions), options.scaleOnSelection);
            _this.provider = _this.multiLegend.getProvider();
            _this.options = options;
            return _this;
        }
        GBars.prototype.renderLegend = function (parentDiv) {
            this.multiLegend.renderContents(parentDiv);
        };
        GBars.prototype.resize = function (w, h, notify, animate) {
            this.size = [w, h];
            var width = this.margin.netWidth(w);
            var height = this.margin.netHeight(h);
            if (this.seriesAxis.setWidth(width)) {
                this.marginChanged(notify, animate);
            }
            else {
                this.valuesAxis.setSize(width, height, animate);
                if (this.valuesAxis.renderSize[1] > height) {
                    this.size[1] += this.valuesAxis.renderSize[1] - height;
                    h = this.size[1];
                    height = this.valuesAxis.renderSize[1];
                }
                this.seriesAxis.setHeight(height);
                this.barsContent.setSize(width, height, animate);
                this.svg.attr("viewBox", "0 0 " + w + " " + h)
                    .style("height", h + "px");
            }
            return this.size;
        };
        GBars.prototype.mouseToIndices = function (event, onlyGraph) {
            var kC = d3.mouse(this.svg.node());
            var mouseX = kC[0] - this.margin.left;
            var mouseY = kC[1] - this.margin.top;
            if (mouseY < 0 || mouseY > (onlyGraph ? this.barsContent.getHeight() : this.size[1]))
                return null;
            var indices = this.seriesAxis.resolve(mouseX);
            if (indices) {
                indices[2] = this.barsContent.tertiaryIndex(mouseY, indices[0], indices[1]);
            }
            return indices;
        };
        GBars.prototype.handleMouseOverGraph = function () {
            var indices = this.mouseToIndices(d3.event, false);
            if (indices) {
                this.multiLegend.highlightIndex(indices);
                var showValueInTooltip = false;
                if (indices[2] != -1) {
                    showValueInTooltip = this.options.valueDetailsMode != "hover" || !this.barsContent.showValue(indices);
                    var unitIndex = this.provider.dataUnit(indices);
                    this.valuesAxis.highlightAxes([unitIndex]);
                }
                else {
                    this.barsContent.hideValue();
                }
                this.showTooltip(indices, showValueInTooltip);
                return;
            }
            else {
                this.handleMouseOutGraph();
            }
        };
        GBars.prototype.handleMouseOutGraph = function () {
            this.barsContent.hideValue();
            if (this.tooltip)
                this.tooltip.hide();
            this.multiLegend.clearHighlight();
            this.valuesAxis.highlightAxes([]);
        };
        GBars.prototype.handleMouseClickInGraph = function () {
            var event = d3.event;
            var indices = this.mouseToIndices(event, true);
            if (indices && indices[2] != -1) {
                var actions = this.provider.getActions(indices);
                if (actions && actions.length > 0) {
                    this.popupMenu = new PopupMenu();
                    this.popupMenu.setActions(actions);
                    this.popupMenu.openPopupMenu(event);
                    this.popupMenu.positionMenu(event.pageX, event.pageY);
                }
            }
            else {
                if (this.popupMenu) {
                    this.popupMenu.closePopupMenu();
                    this.popupMenu = null;
                }
            }
        };
        GBars.prototype.computeMargin = function () {
            this.margin = new Margin(20, 10, 10, 10)
                .add(this.valuesAxis.computeMargin())
                .add(this.seriesAxis.computeMargin());
        };
        GBars.prototype.renderContents = function (parentDiv, w, h) {
            var _this = this;
            this.size = [w, h];
            var chart = parentDiv.append("div")
                .attr("class", "barchart graph");
            this.svg = chart.append("svg")
                .attr("viewBox", "0 0 " + w + " " + h)
                .style("height", h + "px");
            var primaryExternals = this.multiLegend.getExternalLegend(0);
            var slider;
            if (primaryExternals && primaryExternals.windower) {
                slider = new Slider_1.Slider(primaryExternals.windower);
            }
            this.seriesAxis = new SeriesAxis_1.SeriesAxis(this.provider, slider);
            this.valuesAxis = new ValuesAxis_1.VerticalValuesAxis(du.consolidateDimension(this.provider, 2), ValuesAxis_1.tickStyle(this.options.tickStyle), false);
            this.barsContent = new BarsContent(this.provider, this.multiLegend.getOrnamentMatrix(), this.seriesAxis, this.valuesAxis, this.options.valueDetailsMode == "always");
            this.computeMargin();
            var width = this.margin.netWidth(w);
            var height = this.margin.netHeight(h);
            var graph = this.svg.append("g")
                .attr("transform", "translate(" + this.margin.left + "," + this.margin.top + ")");
            if (this.seriesAxis.renderContents(graph, width, height)) {
                this.computeMargin();
                height = this.margin.netHeight(h);
            }
            this.valuesAxis.setSize(width, height, false);
            this.valuesAxis.renderContents(graph);
            if (this.valuesAxis.renderSize[1] > height) {
                this.size[1] += this.valuesAxis.renderSize[1] - height;
                height = this.valuesAxis.renderSize[1];
            }
            this.seriesAxis.setHeight(height);
            this.barsContent.renderContents(graph, width, height);
            this.svg.on("mouseleave", function () { return _this.handleMouseOutGraph(); });
            this.svg.on("mousemove", function () { return _this.handleMouseOverGraph(); });
            this.svg.on("click", function () { return _this.handleMouseClickInGraph(); });
            this.provider.on("changed", function (event) { return _this.processChange(event); });
            if (primaryExternals && primaryExternals.nameFilter) {
                primaryExternals.nameFilter.renderContents(parentDiv);
            }
            return this.size;
        };
        GBars.prototype.processChange = function (event) {
            var marginImpacted = this.seriesAxis.processChange(event);
            if (this.valuesAxis.processChange(event))
                marginImpacted = true;
            this.barsContent.processChange(event);
            if (marginImpacted)
                this.marginChanged(true, !event.majorChange);
        };
        GBars.prototype.marginChanged = function (notify, animate) {
            this.computeMargin();
            this.resize(this.size[0], this.size[1], notify, animate);
            if (notify)
                this.emit("resizeNeeded", this.size);
        };
        GBars.prototype.showTooltip = function (index, showValue) {
            if (this.tooltip == undefined) {
                this.tooltip = new Tooltip(this.svg, this.size[1]);
            }
            else {
                this.tooltip.setHeight(this.size[1]);
            }
            this.tooltip.hide();
            var p0 = this.provider.dimension(0);
            var tooltipText = p0.label(p0.items()[index[0]], index[0]);
            if (showValue) {
                var val = this.provider.data(index);
                var valueText = this.provider.dataText(val, index);
                if (tooltipText == "")
                    tooltipText = valueText;
                tooltipText = NLS.bind("{0} ({1})", [tooltipText, valueText]);
            }
            if (tooltipText == "")
                return;
            this.tooltip.show(tooltipText);
        };
        return GBars;
    }(Evented));
    exports.GBars = GBars;
});
