var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "view/query/GLinesQueryProvider", "view/query/GLinesQueryProvider"], function (require, exports, GLinesQueryProvider_1, GLinesQueryProvider_2) {
    "use strict";
    exports.__esModule = true;
    var GLinesSingleData = (function (_super) {
        __extends(GLinesSingleData, _super);
        function GLinesSingleData(queriesCount) {
            var _this = _super.call(this) || this;
            _this.queriesCount = queriesCount;
            return _this;
        }
        GLinesSingleData.prototype.setData = function (response, startTime) {
            _super.prototype._setData.call(this, response, startTime);
            var values = response.index !== undefined ? response.values : [];
            this.points = this.extractPoints(values, response.index, this.interval, this._timeDomain);
        };
        GLinesSingleData.prototype.addData = function (response, startTime) {
            var addedTimeDomain = _super.prototype._addData.call(this, response, startTime);
            var values = response.index !== undefined ? response.values : [];
            var counterValues = this.extractPoints(values, response.index, this.interval, addedTimeDomain);
            this.concatPoints(this.points, counterValues);
        };
        return GLinesSingleData;
    }(GLinesQueryProvider_1.Data));
    exports.GLinesSingleData = GLinesSingleData;
    var GLinesAbstractSingleQueryProvider = (function (_super) {
        __extends(GLinesAbstractSingleQueryProvider, _super);
        function GLinesAbstractSingleQueryProvider() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        GLinesAbstractSingleQueryProvider.prototype.processLocalData = function (response, startTime) {
            var data = this.createData();
            data.setData(response, startTime);
            return data;
        };
        GLinesAbstractSingleQueryProvider.prototype.processData = function (response) {
            var wasEmpty = this._data.isEmpty();
            this._data.setData(response, this.getDataStartTime());
            return {
                domainChanged: true,
                xDomainChanged: true,
                dataChanged: true,
                dimensionsChanged: [],
                majorChange: wasEmpty
            };
        };
        GLinesAbstractSingleQueryProvider.prototype.processIncrementalData = function (data, response, startTime) {
            data.addData(response, startTime);
            return {
                domainChanged: true,
                xDomainChanged: true,
                dataChanged: true,
                dimensionsChanged: []
            };
        };
        GLinesAbstractSingleQueryProvider.prototype.getActions = function (index) {
            return this.getCounterActions(index[this.countersDimIndex]);
        };
        return GLinesAbstractSingleQueryProvider;
    }(GLinesQueryProvider_2.GLinesQueryProvider));
    exports.GLinesAbstractSingleQueryProvider = GLinesAbstractSingleQueryProvider;
});
