var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "view/query/GLinesAbstractWildcardQueryProvider", "view/query/queryUtil"], function (require, exports, GLinesAbstractWildcardQueryProvider_1, qu) {
    "use strict";
    exports.__esModule = true;
    ;
    var WildcardData = (function (_super) {
        __extends(WildcardData, _super);
        function WildcardData(queriesCount) {
            var _this = _super.call(this, queriesCount) || this;
            _this.dims = [0, 1];
            _this.countersDimIndex = 1;
            return _this;
        }
        WildcardData.prototype.extractPoints = function (instances, values, interval, timeDomain, instanceNames) {
            var ret = [];
            for (var _i = 0, instances_1 = instances; _i < instances_1.length; _i++) {
                var instance = instances_1[_i];
                var instanceIndex = qu.arrayIndexOf(instanceNames, instance.name);
                var vindex = instance.index * this.queriesCount;
                var instanceValues = [];
                var _loop_1 = function (i) {
                    var bindex = vindex + i;
                    var counterValues = values.map(function (v) { return v[bindex]; });
                    instanceValues[i] = qu.toCoordinates(counterValues, interval, timeDomain);
                };
                for (var i = 0; i < this.queriesCount; i++) {
                    _loop_1(i);
                }
                ret[instanceIndex] = instanceValues;
            }
            return ret;
        };
        WildcardData.prototype.concatPoints = function (to, from) {
            qu.concatDeepCoordinates(to, from, 1);
        };
        return WildcardData;
    }(GLinesAbstractWildcardQueryProvider_1.GLinesWildcardData));
    var GLinesWildcardQueryProvider = (function (_super) {
        __extends(GLinesWildcardQueryProvider, _super);
        function GLinesWildcardQueryProvider(counterQuerySet, options) {
            var _this = _super.call(this, counterQuerySet, options, new WildcardData(counterQuerySet.counterQueries.length)) || this;
            _this.countersDimIndex = 1;
            _this.instancesDimIndex = 0;
            _this.dimensions = [
                _this.instances,
                _this.createCountersDimension()
            ];
            return _this;
        }
        GLinesWildcardQueryProvider.prototype.createData = function () {
            return new WildcardData(this.counterQueries.length);
        };
        GLinesWildcardQueryProvider.prototype.getRequestUrl = function (sampleDomain, interval) {
            var url = _super.prototype.getRequestUrl.call(this, sampleDomain, interval);
            url += this.session.hostsRoot.getEnabledHostsQuery();
            return url;
        };
        return GLinesWildcardQueryProvider;
    }(GLinesAbstractWildcardQueryProvider_1.GLinesAbstractWildcardQueryProvider));
    exports.GLinesWildcardQueryProvider = GLinesWildcardQueryProvider;
});
