var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "view/query/GLastSingleQueryProvider", "view/query/GLastWildcardQueryProvider", "view/query/GLastDoubleWildcardQueryProvider", "view/query/GRangeSingleQueryProvider", "view/query/GRangeWildcardQueryProvider", "view/query/GRangeDoubleWildcardQueryProvider", "view/query/GAgentSingleQueryProvider", "view/query/GAgentWildcardQueryProvider", "view/query/GAgentDoubleWildcardQueryProvider", "view/query/GCompareLastSingleQueryProvider", "view/query/GCompareLastWildcardQueryProvider", "view/query/GLinesSingleQueryProvider", "view/query/GLinesWildcardQueryProvider", "view/query/GLinesAgentSingleQueryProvider", "view/query/GLinesAgentWildcardQueryProvider", "view/query/GLinesCompareSingleQueryProvider", "view/query/GLinesCompareWildcardQueryProvider", "view/GBars", "view/GPie", "view/GTable", "view/GLines", "view/util/DimensionUtil", "view/util/SeriesOptions", "jrptlib/Properties!APPMSG", "ui/Prefs!"], function (require, exports, GLastSingleQueryProvider_1, GLastWildcardQueryProvider_1, GLastDoubleWildcardQueryProvider_1, GRangeSingleQueryProvider_1, GRangeWildcardQueryProvider_1, GRangeDoubleWildcardQueryProvider_1, GAgentSingleQueryProvider_1, GAgentWildcardQueryProvider_1, GAgentDoubleWildcardQueryProvider_1, GCompareLastSingleQueryProvider_1, GCompareLastWildcardQueryProvider_1, GLinesSingleQueryProvider_1, GLinesWildcardQueryProvider_1, GLinesAgentSingleQueryProvider_1, GLinesAgentWildcardQueryProvider_1, GLinesCompareSingleQueryProvider_1, GLinesCompareWildcardQueryProvider_1, GBars_1, GPie_1, GTable_1, GLines_1, du, SeriesOptions_1, APPMSG, Prefs) {
    "use strict";
    exports.__esModule = true;
    function allSessions(session) {
        var sessions = [];
        sessions.push(session);
        sessions = sessions.concat(session.getSelectedSessions());
        return sessions;
    }
    var pgr = Prefs.pagingEnabled ? function (n) { return n; } : function (n) { return 0; };
    var MAX_PRIMARY = 30;
    var MAX_SECONDARY = 12;
    var MAX_STACK = 30;
    var MAX_ARC = pgr(20);
    var MAX_DONUT = pgr(20);
    var MAX_ROW = 30;
    var MAX_COLUMN = pgr(12);
    var MAX_ROW_GROUP = pgr(2);
    var MAX_PRIMARY_LINES = 16;
    var MAX_SECONDARY_LINES = 8;
    function singularDim(name, lines, counterProvider) {
        switch (name) {
            case "counter": return APPMSG.DimCounter;
            case "compare": return lines ? APPMSG.DimLineCompare : APPMSG.DimCompare;
            default: {
                var wildcardDesc = counterProvider.resolveWildcard(name.split("/"));
                return wildcardDesc ? wildcardDesc.label : name;
            }
        }
    }
    function pluralDim(name, lines, counterProvider) {
        switch (name) {
            case "counter": return APPMSG.DimCounters;
            case "compare": return lines ? APPMSG.DimLineCompares : APPMSG.DimCompares;
            default: {
                var wildcardDesc = counterProvider.resolveWildcard(name.split("/"));
                return wildcardDesc ? wildcardDesc.pluralLabel : name;
            }
        }
    }
    function getTranslateDim(kind) {
        switch (kind) {
            case LabelKind.SINGULAR: return singularDim;
            case LabelKind.PLURAL: return pluralDim;
            default: throw kind;
        }
    }
    var LabelKind;
    (function (LabelKind) {
        LabelKind[LabelKind["SINGULAR"] = 0] = "SINGULAR";
        LabelKind[LabelKind["PLURAL"] = 1] = "PLURAL";
    })(LabelKind = exports.LabelKind || (exports.LabelKind = {}));
    var DEFAULT_LEGEND_MATRIX = {
        "primary": { legend: false, paging: MAX_PRIMARY, filter: MAX_PRIMARY },
        "secondary": { legend: true, paging: MAX_SECONDARY, filter: MAX_SECONDARY },
        "stack": { legend: true, paging: MAX_STACK, filter: MAX_STACK },
        "arc": { legend: true, paging: MAX_ARC, filter: MAX_ARC },
        "donut": { legend: true, paging: MAX_DONUT, filter: MAX_DONUT },
        "row": { legend: false, paging: MAX_ROW, filter: MAX_ROW },
        "column": { legend: false, paging: MAX_COLUMN, filter: MAX_COLUMN },
        "rowGroup": { legend: false, paging: MAX_ROW_GROUP, filter: MAX_ROW_GROUP }
    };
    var DEFAULT_LEGEND_LINES = {
        "primary": { legend: true, paging: MAX_PRIMARY_LINES, filter: MAX_PRIMARY_LINES },
        "secondary": { legend: true, paging: MAX_SECONDARY_LINES, filter: MAX_SECONDARY_LINES }
    };
    var DefaultableSeriesOptionsModel = (function (_super) {
        __extends(DefaultableSeriesOptionsModel, _super);
        function DefaultableSeriesOptionsModel(isLines) {
            var _this = _super.call(this) || this;
            _this.defaults = isLines ? DEFAULT_LEGEND_LINES : DEFAULT_LEGEND_MATRIX;
            return _this;
        }
        DefaultableSeriesOptionsModel.prototype.fillDefaults = function (serie, serieOptions) {
            if (serieOptions.legend === null)
                serieOptions.legend = this.defaults[serie].legend;
            if (serieOptions.paging === null)
                serieOptions.paging = this.defaults[serie].paging;
            if (serieOptions.filter === null)
                serieOptions.filter = this.defaults[serie].filter;
        };
        return DefaultableSeriesOptionsModel;
    }(SeriesOptions_1.SeriesOptionsModel));
    var AllDefaultSeriesOptionsModel = (function (_super) {
        __extends(AllDefaultSeriesOptionsModel, _super);
        function AllDefaultSeriesOptionsModel(isLines) {
            return _super.call(this, isLines) || this;
        }
        AllDefaultSeriesOptionsModel.prototype.set = function (serie, dim, legend, sorting, paging, filter) {
            if (filter === undefined)
                filter = paging;
            this.series[serie] = { dim: dim, legend: legend, paging: paging, filter: filter, sorting: sorting };
            this.fillDefaults(serie, this.series[serie]);
        };
        return AllDefaultSeriesOptionsModel;
    }(DefaultableSeriesOptionsModel));
    var OverridableSeriesOptionsModel = (function (_super) {
        __extends(OverridableSeriesOptionsModel, _super);
        function OverridableSeriesOptionsModel(original, isLines) {
            var _this = _super.call(this, isLines) || this;
            for (var s in original.series) {
                var os = original.series[s];
                _this.series[s] = { dim: os.dim, legend: os.legend, sorting: os.sorting, paging: os.paging, filter: os.filter };
            }
            return _this;
        }
        OverridableSeriesOptionsModel.prototype.set = function (serie, dim, legend, sorting, paging, filter) {
            if (filter === undefined)
                filter = paging;
            var actualSerie = this.getSerie(dim);
            var options = this.series[actualSerie];
            if (options.legend === null)
                options.legend = legend;
            if (options.sorting === null)
                options.sorting = sorting;
            if (options.paging === null)
                options.paging = paging;
            if (options.filter === null)
                options.filter = filter;
            this.fillDefaults(actualSerie, options);
        };
        return OverridableSeriesOptionsModel;
    }(DefaultableSeriesOptionsModel));
    var DefaultSeriesOptionsModel = (function (_super) {
        __extends(DefaultSeriesOptionsModel, _super);
        function DefaultSeriesOptionsModel(isLines) {
            return _super.call(this, isLines) || this;
        }
        DefaultSeriesOptionsModel.prototype.set = function (serie, dim, legend, sorting, paging, filter) {
            this.series[serie] = { dim: dim, legend: null, paging: null, filter: null, sorting: null };
        };
        return DefaultSeriesOptionsModel;
    }(DefaultableSeriesOptionsModel));
    var QueryFactory = (function () {
        function QueryFactory(cqSet) {
            if (cqSet.isEmpty())
                throw APPMSG.EmptyView;
        }
        QueryFactory.prototype.dispose = function () {
            if (this.queryProvider) {
                this.queryProvider.setOff();
                this.queryProvider.dispose();
            }
        };
        QueryFactory.prototype.getQueryProvider = function () {
            return this.queryProvider;
        };
        QueryFactory.prototype.getViewProvider = function () {
            if (this.viewProvider)
                return this.viewProvider;
            return this.queryProvider;
        };
        QueryFactory.prototype.getAcceptableDimensions = function (counterProvider, labelKind) {
            var _this = this;
            var translate = getTranslateDim(labelKind);
            return this.acceptableDimIds.map(function (id) {
                return {
                    value: id,
                    label: translate(id, _this instanceof LineQueryFactory, counterProvider)
                };
            });
        };
        QueryFactory.prototype.getDefaultOptions = function () {
            var options = new DefaultSeriesOptionsModel(this.isLines());
            this.applyDefaults(options);
            return options;
        };
        QueryFactory.prototype.getSeriesOptions = function (options) {
            var actualOptions = options ?
                new OverridableSeriesOptionsModel(options, this.isLines()) :
                new AllDefaultSeriesOptionsModel(this.isLines());
            this.applyDefaults(actualOptions);
            var ret = new SeriesOptions_1.SeriesOptions(this.getSeries());
            ret.applyOptions(actualOptions, this.dimIds, this.acceptableDimIds);
            return ret;
        };
        return QueryFactory;
    }());
    exports.QueryFactory = QueryFactory;
    var MatrixQueryFactory = (function (_super) {
        __extends(MatrixQueryFactory, _super);
        function MatrixQueryFactory(cqSet, session, viewKind) {
            var _this = _super.call(this, cqSet) || this;
            var wildcards = cqSet.getWildcards();
            var timeRanges = session.getSelectedTimeRanges();
            var sessionSet = session.getSelectedSessions();
            var multiCounters = cqSet.count() > 1;
            if (wildcards === null) {
                throw APPMSG.InvalidCounters;
            }
            else if (wildcards.length == 0) {
                _this.acceptableDimIds = ["counter", "compare"].concat(cqSet.getWildcards(true));
                _this.options = {
                    bars: function (options) {
                        options.set("primary", "counter", multiCounters ? null : false, false, 0);
                        options.set("secondary", "compare", true, false, null);
                    },
                    pie: function (options) {
                        options.set("arc", "counter", multiCounters ? null : false, false, null);
                        options.set("donut", "compare", true, false, null);
                    },
                    table: function (options) {
                        options.set("row", "counter", null, false, 0);
                        options.set("column", "compare", null, false, null);
                    }
                };
                if (timeRanges.length != 1) {
                    _this.queryProvider = new GRangeSingleQueryProvider_1.GRangeSingleQueryProvider(cqSet);
                    _this.dimIds = ["counter", "compare"];
                }
                else {
                    var bounds = session.getTimeRangeSampleBounds(timeRanges[0]);
                    if (session.hostsRoot.isCompare()) {
                        _this.queryProvider = new GAgentSingleQueryProvider_1.GAgentSingleQueryProvider(cqSet, bounds);
                        _this.dimIds = ["counter", "compare"];
                    }
                    else if (sessionSet.length > 0) {
                        _this.queryProvider = new GCompareLastSingleQueryProvider_1.GCompareLastSingleQueryProvider(cqSet, allSessions(session), bounds);
                        _this.dimIds = ["counter", "compare"];
                    }
                    else {
                        _this.queryProvider = new GLastSingleQueryProvider_1.GLastSingleQueryProvider(cqSet, bounds);
                        _this.dimIds = ["counter"];
                    }
                }
            }
            else if (cqSet.isCrossWildcard()) {
                _this.acceptableDimIds = cqSet.getWildcards(true);
                if (multiCounters) {
                    _this.acceptableDimIds.push("counter");
                    _this.options = {
                        bars: function (options) {
                            options.set("primary", wildcards[0], null, true, null);
                            options.set("secondary", "counter", null, false, 0);
                            options.set("stack", wildcards[1], null, true, null);
                        },
                        pie: function (options) {
                        },
                        table: function (options) {
                            options.set("row", wildcards[0], null, true, null);
                            options.set("column", wildcards[1], null, true, null);
                            options.set("rowGroup", "counter", null, false, 0);
                        }
                    };
                }
                else {
                    if (viewKind != 2)
                        _this.acceptableDimIds.push("compare");
                    _this.options = {
                        bars: function (options) {
                            options.set("primary", wildcards[0], null, true, null);
                            options.set("secondary", wildcards[1], null, true, null);
                            options.set("stack", "compare", null, false, null);
                        },
                        pie: function (options) {
                            options.set("arc", wildcards[0], null, true, null);
                            options.set("donut", wildcards[1], null, true, null);
                        },
                        table: function (options) {
                            options.set("row", wildcards[0], null, true, null);
                            options.set("column", "compare", null, false, null);
                            options.set("rowGroup", wildcards[1], null, true, null);
                        }
                    };
                }
                if (timeRanges.length != 1) {
                    if (multiCounters) {
                        throw APPMSG.TooMuchDimensions;
                    }
                    else {
                        if (viewKind == 2) {
                            throw APPMSG.TooMuchDimensions;
                        }
                        else {
                            _this.queryProvider = new GRangeDoubleWildcardQueryProvider_1.GRangeDoubleWildcardQueryProvider(cqSet);
                            _this.viewProvider = du.reduce(_this.queryProvider, 1);
                            _this.dimIds = [wildcards[0], wildcards[1], "compare"];
                        }
                    }
                }
                else {
                    var bounds = session.getTimeRangeSampleBounds(timeRanges[0]);
                    if (session.hostsRoot.isCompare()) {
                        if (multiCounters) {
                            throw APPMSG.TooMuchDimensions;
                        }
                        else {
                            if (viewKind == 2) {
                                throw APPMSG.TooMuchDimensions;
                            }
                            else {
                                _this.queryProvider = new GAgentDoubleWildcardQueryProvider_1.GAgentDoubleWildcardQueryProvider(cqSet);
                                _this.viewProvider = du.reduce(_this.queryProvider, 1);
                                _this.dimIds = [wildcards[0], wildcards[1], "compare"];
                            }
                        }
                    }
                    else if (sessionSet.length > 0) {
                        throw APPMSG.TooMuchDimensions;
                    }
                    else {
                        if (multiCounters) {
                            if (viewKind == 2) {
                                throw APPMSG.TooMuchDimensions;
                            }
                            else {
                                _this.queryProvider = new GLastDoubleWildcardQueryProvider_1.GLastDoubleWildcardQueryProvider(cqSet, bounds);
                                _this.dimIds = [wildcards[0], wildcards[1], "counter"];
                            }
                        }
                        else {
                            _this.queryProvider = new GLastDoubleWildcardQueryProvider_1.GLastDoubleWildcardQueryProvider(cqSet, bounds);
                            _this.viewProvider = du.reduce(_this.queryProvider, 1);
                            _this.dimIds = [wildcards[0], wildcards[1]];
                        }
                    }
                }
            }
            else if (wildcards.length >= 1) {
                _this.acceptableDimIds = cqSet.getWildcards(true);
                if (multiCounters) {
                    if (viewKind != 2)
                        _this.acceptableDimIds.push("compare");
                    _this.acceptableDimIds.push("counter");
                    _this.options = {
                        bars: function (options) {
                            options.set("primary", wildcards[0], null, true, null);
                            options.set("secondary", "counter", null, false, 0);
                            options.set("stack", "compare", null, false, null);
                        },
                        pie: function (options) {
                            options.set("arc", wildcards[0], null, true, null);
                            options.set("donut", "counter", null, false, 0);
                        },
                        table: function (options) {
                            options.set("row", wildcards[0], null, true, null);
                            options.set("column", "compare", null, false, null);
                            options.set("rowGroup", "counter", null, false, 0);
                        }
                    };
                }
                else {
                    _this.acceptableDimIds.push("compare");
                    _this.options = {
                        bars: function (options) {
                            options.set("primary", wildcards[0], null, true, null);
                            options.set("secondary", "compare", null, false, null);
                        },
                        pie: function (options) {
                            options.set("arc", wildcards[0], null, true, null);
                            options.set("donut", "compare", null, false, null);
                        },
                        table: function (options) {
                            options.set("row", wildcards[0], null, true, null);
                            options.set("column", "compare", null, false, null);
                        }
                    };
                }
                if (timeRanges.length != 1) {
                    if (multiCounters) {
                        if (viewKind == 2) {
                            throw APPMSG.TooMuchDimensions;
                        }
                        else {
                            _this.queryProvider = new GRangeWildcardQueryProvider_1.GRangeWildcardQueryProvider(cqSet);
                            _this.dimIds = [wildcards[0], "compare", "counter"];
                        }
                    }
                    else {
                        _this.queryProvider = new GRangeWildcardQueryProvider_1.GRangeWildcardQueryProvider(cqSet);
                        _this.viewProvider = du.reduce(_this.queryProvider, 1);
                        _this.dimIds = [wildcards[0], "compare"];
                    }
                }
                else {
                    var bounds = session.getTimeRangeSampleBounds(timeRanges[0]);
                    if (session.hostsRoot.isCompare()) {
                        if (multiCounters) {
                            if (viewKind == 2) {
                                throw APPMSG.TooMuchDimensions;
                            }
                            else {
                                _this.queryProvider = new GAgentWildcardQueryProvider_1.GAgentWildcardQueryProvider(cqSet, bounds);
                                _this.dimIds = [wildcards[0], "compare", "counter"];
                            }
                        }
                        else {
                            _this.queryProvider = new GAgentWildcardQueryProvider_1.GAgentWildcardQueryProvider(cqSet, bounds);
                            _this.viewProvider = du.reduce(_this.queryProvider, 1);
                            _this.dimIds = [wildcards[0], "compare"];
                        }
                    }
                    else if (sessionSet.length > 0) {
                        if (multiCounters) {
                            if (viewKind == 2) {
                                throw APPMSG.TooMuchDimensions;
                            }
                            else {
                                _this.queryProvider = new GCompareLastWildcardQueryProvider_1.GCompareLastWildcardQueryProvider(cqSet, allSessions(session), bounds);
                                _this.dimIds = [wildcards[0], "compare", "counter"];
                            }
                        }
                        else {
                            _this.queryProvider = new GCompareLastWildcardQueryProvider_1.GCompareLastWildcardQueryProvider(cqSet, allSessions(session), bounds);
                            _this.viewProvider = du.reduce(_this.queryProvider, 1);
                            _this.dimIds = [wildcards[0], "compare"];
                        }
                    }
                    else {
                        _this.queryProvider = new GLastWildcardQueryProvider_1.GLastWildcardQueryProvider(cqSet, bounds);
                        if (multiCounters) {
                            _this.dimIds = [wildcards[0], "counter"];
                        }
                        else {
                            _this.viewProvider = du.reduce(_this.queryProvider, 1);
                            _this.dimIds = [wildcards[0]];
                        }
                    }
                }
            }
            else {
                throw APPMSG.TooMuchWildcards;
            }
            if (_this.queryProvider) {
                _this.queryProvider.setSession(session);
                _this.queryProvider.setOn();
            }
            return _this;
        }
        MatrixQueryFactory.prototype.scalePer = function (dimId) {
            if (!dimId)
                return;
            var dimIndex = this.dimIds.indexOf(dimId);
            if (dimIndex == -1) {
                if (this.acceptableDimIds.indexOf(dimId) == -1)
                    throw "Dimension " + dimId + " not defined";
                return;
            }
            this.viewProvider = du.splitUnit(this.getViewProvider(), dimIndex);
        };
        MatrixQueryFactory.prototype.isLines = function () {
            return false;
        };
        return MatrixQueryFactory;
    }(QueryFactory));
    exports.MatrixQueryFactory = MatrixQueryFactory;
    var BarsQueryFactory = (function (_super) {
        __extends(BarsQueryFactory, _super);
        function BarsQueryFactory(cqSet, session) {
            return _super.call(this, cqSet, session, 1) || this;
        }
        BarsQueryFactory.prototype.getSeries = function () {
            return GBars_1.BarSeries;
        };
        BarsQueryFactory.prototype.applyDefaults = function (options) {
            this.options.bars(options);
        };
        return BarsQueryFactory;
    }(MatrixQueryFactory));
    exports.BarsQueryFactory = BarsQueryFactory;
    var PieQueryFactory = (function (_super) {
        __extends(PieQueryFactory, _super);
        function PieQueryFactory(cqSet, session) {
            return _super.call(this, cqSet, session, 2) || this;
        }
        PieQueryFactory.prototype.getSeries = function () {
            return GPie_1.PieSeries;
        };
        PieQueryFactory.prototype.applyDefaults = function (options) {
            this.options.pie(options);
        };
        return PieQueryFactory;
    }(MatrixQueryFactory));
    exports.PieQueryFactory = PieQueryFactory;
    var TableQueryFactory = (function (_super) {
        __extends(TableQueryFactory, _super);
        function TableQueryFactory(cqSet, session) {
            return _super.call(this, cqSet, session, 0) || this;
        }
        TableQueryFactory.prototype.getSeries = function () {
            return GTable_1.TableSeries;
        };
        TableQueryFactory.prototype.applyDefaults = function (options) {
            this.options.table(options);
        };
        return TableQueryFactory;
    }(MatrixQueryFactory));
    exports.TableQueryFactory = TableQueryFactory;
    var LineQueryFactory = (function (_super) {
        __extends(LineQueryFactory, _super);
        function LineQueryFactory(cqSet, session, options) {
            var _this = _super.call(this, cqSet) || this;
            var wildcards = cqSet.getWildcards();
            var timeRanges = session.getSelectedTimeRanges();
            var sessionSet = session.getSelectedSessions();
            var multiCounters = cqSet.count() > 1;
            if (wildcards === null) {
                throw APPMSG.InvalidCounters;
            }
            else if (wildcards.length == 0) {
                _this.acceptableDimIds = ["counter", "compare"].concat(cqSet.getWildcards(true));
                if (multiCounters) {
                    _this.options = {
                        lines: function (options) {
                            options.set("primary", "counter", null, false, 0);
                            options.set("secondary", "compare", null, false, null);
                        }
                    };
                }
                else {
                    _this.options = {
                        lines: function (options) {
                            options.set("primary", "compare", null, false, null);
                            options.set("secondary", "counter", false, false, 0);
                        }
                    };
                }
                if (session.hostsRoot.isCompare()) {
                    _this.queryProvider = new GLinesAgentSingleQueryProvider_1.GLinesAgentSingleQueryProvider(cqSet, options);
                    _this.dimIds = ["counter", "compare"];
                }
                else if (sessionSet.length > 0) {
                    _this.queryProvider = new GLinesCompareSingleQueryProvider_1.GLinesCompareSingleQueryProvider(cqSet, allSessions(session), options);
                    _this.dimIds = ["counter", "compare"];
                }
                else {
                    _this.queryProvider = new GLinesSingleQueryProvider_1.GLinesSingleQueryProvider(cqSet, options);
                    _this.dimIds = ["counter"];
                }
            }
            else if (cqSet.isCrossWildcard()) {
                throw APPMSG.TooMuchDimensions;
            }
            else {
                _this.acceptableDimIds = cqSet.getWildcards(true);
                if (multiCounters) {
                    _this.acceptableDimIds.push("counter");
                    _this.options = {
                        lines: function (options) {
                            options.set("primary", wildcards[0], null, true, null);
                            options.set("secondary", "counter", null, false, 0);
                        }
                    };
                }
                else {
                    _this.acceptableDimIds.push("compare");
                    _this.options = {
                        lines: function (options) {
                            options.set("primary", wildcards[0], null, true, null);
                            options.set("secondary", "compare", null, false, null);
                        }
                    };
                }
                if (session.hostsRoot.isCompare()) {
                    if (multiCounters) {
                        throw APPMSG.TooMuchWildcardsComp;
                    }
                    else {
                        _this.queryProvider = new GLinesAgentWildcardQueryProvider_1.GLinesAgentWildcardQueryProvider(cqSet, options);
                        _this.viewProvider = du.reduceLine(_this.queryProvider, 1);
                        _this.dimIds = [wildcards[0], "compare"];
                    }
                }
                else if (sessionSet.length > 0) {
                    if (multiCounters) {
                        throw APPMSG.TooMuchWildcardsComp;
                    }
                    else {
                        _this.queryProvider = new GLinesCompareWildcardQueryProvider_1.GLinesCompareWildcardQueryProvider(cqSet, allSessions(session), options);
                        _this.dimIds = [wildcards[0], "compare"];
                    }
                }
                else {
                    _this.queryProvider = new GLinesWildcardQueryProvider_1.GLinesWildcardQueryProvider(cqSet, options);
                    _this.viewProvider = du.reduceLine(_this.queryProvider, 1);
                    _this.dimIds = [wildcards[0]];
                }
            }
            if (_this.queryProvider) {
                _this.queryProvider.setSession(session);
                _this.queryProvider.setOn();
            }
            return _this;
        }
        LineQueryFactory.prototype.applyDefaults = function (options) {
            this.options.lines(options);
        };
        LineQueryFactory.prototype.getSeries = function () {
            return GLines_1.LineSeries;
        };
        LineQueryFactory.prototype.scalePer = function (dimId) {
            if (!dimId)
                return;
            var dimIndex = this.dimIds.indexOf(dimId);
            if (dimIndex == -1) {
                return;
            }
            this.viewProvider = du.splitUnitLine(this.getViewProvider(), dimIndex);
        };
        LineQueryFactory.prototype.isLines = function () {
            return true;
        };
        return LineQueryFactory;
    }(QueryFactory));
    exports.LineQueryFactory = LineQueryFactory;
});
