require([
    'dojo/dom',
    'dojo/dom-construct',
    "dojo/_base/array",
    "dojo/request",
    "dojo/json",
    'dojo/store/JsonRest',
    "dojo/domReady!"
], function (dom, domConstruct, arrayUtil, request, JSON, JsonRest) {
    var greetingNode = dom.byId('greeting');
    domConstruct.place('<i> Dojo!</i>', greetingNode);
    var reportsDiv = dom.byId('reports');
    request.get("../reports?f=json", {
        // Parse data from JSON to a JavaScript object
        handleAs: "json"
    }).then(
            function(data){
            	var html = '<ul	class="list-group">';
            	arrayUtil.forEach(data.reports, function(report,i){
                    html += '<li class="list-group-item">' + report.name + "</li>";
                });
                html += "</ul>";
                reportsDiv.innerHTML = html;
            },
            function(error){
            	reportsDiv.innerHTML = error;
            }
        );
    var reportsStore = new JsonRest({target:"../reports/"})
});